Miscellaneous Communications Functions
Communications Module

## Classes

class | itpp::EXIT
| EXtrinsic Information Transfer (EXIT) chart. More...
class | itpp::Multilateration
| Multilateration class for 3D indoor localization More...
class | itpp::STC
| Space Time block Codes (STC) class. More...

## Functions

bmat | itpp::graycode (int m)
| Generate Gray code of blocklength m.
int | itpp::hamming_distance (const bvec &a, const bvec &b)
| Calculate the Hamming distance between a and b.
int | itpp::weight (const bvec &a)
| Calculate the Hamming weight of a.
vec | itpp::waterfilling (const vec &alpha, double P)
| Compute the water-filling solution.

## Detailed Description

## Function Documentation

## graycode()

ITPP_EXPORT bmat itpp::graycode | ( | int | m | ) |

Generate Gray code of blocklength m.

The codes are contained as binary codewords {0,1} in the rows of the returned matrix. See also the `gray()` function in `math/scalfunc.h`.

Definition at line 39 of file commfunc.cpp.

References itpp::concat(), itpp::graycode(), itpp::ones_b(), itpp::reverse(), itpp::to_bmat(), and itpp::zeros_b().

Referenced by itpp::graycode(), itpp::QAM::set_M(), itpp::PSK::set_M(), itpp::PAM_c::set_M(), itpp::PAM::set_M(), itpp::ND_UPAM::set_M(), itpp::ND_UQAM::set_M(), and itpp::ND_UPSK::set_M().

## hamming_distance()

ITPP_EXPORT int itpp::hamming_distance | ( | const bvec & | a,
|  | const bvec & | b
| ) |  |

Calculate the Hamming distance between a and b.

Definition at line 59 of file commfunc.cpp.

References it_assert_debug, and itpp::Array< T >::size().

## weight()

ITPP_EXPORT int itpp::weight | ( | const bvec & | a | ) |

Calculate the Hamming weight of a.

Definition at line 71 of file commfunc.cpp.

References itpp::Array< T >::size().

Referenced by itpp::Extended_Golay::decode().

## waterfilling()

ITPP_EXPORT vec itpp::waterfilling | ( | const vec & | alpha,
|  | double | P
| ) |  |

Compute the water-filling solution.

This function computes the solution of the water-filling problem

subject to

Parameters

  alpha | vector of gains (must have strictly positive elements)
  P | power constraint

Returns
  vector of power allocations

The computational complexity of the method is at most

Definition at line 82 of file commfunc.cpp.

References it_assert, and itpp::length().

Generated on Mon Jun 10 2024 11:49:30 for IT++ by Doxygen 1.9.8